import Dashboard from './dashboard';
declare class DashboardChartEventSender {
    chartId: string;
    dashboard: Dashboard;
    constructor(chartId: string, dashboard: Dashboard);
    /**
     * Send message to embedded app via dashboard.
     */
    _send(msgName: string, ...payload: unknown[]): Promise<[unknown]>;
}
declare const DashboardChart_base: {
    new (...args: any[]): {
        setHighlight(value: import("./types").PlainObject): Promise<void>;
        getHighlight(): Promise<import("./types").PlainObject>;
        getData(): Promise<object>;
        _send(msgName: string, ...payload: unknown[]): Promise<[unknown]>;
    };
} & {
    new (...args: any[]): {
        setFilter(value: import("./types").PlainObject): Promise<void>;
        getFilter(): Promise<import("./types").PlainObject>;
        _send(msgName: string, ...payload: unknown[]): Promise<[unknown]>;
    };
} & {
    new (...args: any[]): {
        refresh(): Promise<void>;
        _send(msgName: string, ...payload: unknown[]): Promise<[unknown]>;
    };
} & {
    new (...args: any[]): {
        _eventHandlers: Record<import("./types").EmbedChartEvent, Record<string, {
            handle: import("./types").EventHandler;
            options: import("./types").EventHandlerOptions;
        }>>;
        _handleEvent(event: import("./types").EmbedChartEvent, payload: import("./types").EventHandlerPayload, handlerIds: string[]): void;
        addEventListener(event: import("./types").EmbedChartEvent, eventHandler: import("./types").EventHandler, options?: import("./types").EventHandlerOptions | undefined): Promise<unknown>;
        removeEventListener(event: import("./types").EmbedChartEvent, eventHandler: import("./types").EventHandler, options?: import("./types").EventHandlerOptions | undefined): Promise<unknown>;
        _send(msgName: string, ...payload: unknown[]): Promise<[unknown]>;
    };
} & typeof DashboardChartEventSender;
export default class DashboardChart extends DashboardChart_base {
}
export type { DashboardChart };
